<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<title>An API for workflow jobs</title>
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<link href="http://purl.org/dc/elements/1.1/" rel="schema.DC" />
<meta content="Martin Haase / DAASI International" name="DC.creator" />
<meta content="2009-07-22T16:29:08.37" name="DC.date" />
<link rel="stylesheet" href="../help.css" charset="utf-8"
	type="text/css" />
</head>

<body>
<h1 id="toc0">An API for workflow jobs</h1>
<P>Here we describe what is done once a workflow is submitted by the
users. A workflow job is represented by the class WorkflowJob. It
does most of its work in the constructor: 
</P>
<OL START="0" TYPE="1">
	<LI><P>The main constructor for a WorkflowJob takes three arguments:</P>
	<OL TYPE="a">
		<LI><P>   the TextGridObject (TGO) representing the uninstantiated
		Workflow (tgwf format)
		</P></LI>
		<LI><P>   a String with the target project ID (e.g. TGPR123)</P></LI>
		<LI><P>   an ArrayList containg the URIs of the input TGOs to be
		processed</P></LI>
	</OL>
	</LI>
	<LI TYPE="1"><P>After reading the contents of the Workflow TGO, any stale TGO
	URIs possibly present in the workflow will be cleared and the URIs
	of the input TGOs will be inserted.</P></LI>
	<LI TYPE="1"><P>For each configuration parameter, it is checked whether it
	has to be encoded in Base64 format (as specified in the tgwf), and
	the full content of the respective parameter will be replaced by its
	encoded string.</P></LI>
	<LI TYPE="1"><P>The algorithm tries to set the target project in the XSLT
	stylesheet for the new metadata. Specifically, it looks for the Path
	“tgwf:tgwf/tgwf:metadatatransformation/xsl:transform/xsl:template/tgc:tgObjectMetadata/tgmd:administrative/tgmd:client/tgmd:project&quot;
	and replaces the projectId found there with the one given by the
	target project ID string. This might fail due to the nature of the
	stylesheet given. In this case the workflow will not be able to
	start.</P></LI>
	<LI TYPE="1"><P>Now further settings known in the TextGridLab will be
	inserted:</P>
	<UL TYPE="a">
		<LI><P>   CRUDs instance endpoint</P></LI>
		<LI><P>   TextGrid SessionID of the user</P></LI>
		<LI><P>   the logParameter for the loggingService</P></LI>
		<LI><P>   the description of the Workflow (taken from the TGO's
		title given in its metadata).</P></LI>
	</UL>
	</LI>
	<LI TYPE="1"><P>Now that the tgwf workflow is fully instantiated, it is
	transformed by an XSL engine according to the rules in the XSLT
	stylesheet described above into GridWorkflowDL format, which is
	stored in a String variable for later execution.</P></LI>
</OL>
<P>If everything went well during instantiation of the tgwf workflow
and its transformation, the public method start() can be executed,
meaning it will be transferred to the GWES engine under the user's
name (initiated), and started. The further life of the job can be
observed in the JobManagement view in the GUI (see below).</P>
<P>There is another constructor which takes only a String with the
workflowID known by the GWES engine. This one is used when querying
the GWES engine for properties of the active, or terminated, or
completed workflows. Various public functions will use the data
retrieved by this constructor, see the API documentation for a full
list of them.</P>

</body>
</html>